# Esercizio PNLI 37 - Classificatore

# DATI
param nP;
set P := 1..nP;
param x {P};
param y {P};
param f {P};
param M := sqrt(
                (max{i in P} y[i] - min{i in P} y[i])^2 +
                (max{i in P} x[i] - min{i in P} x[i])^2
               );

# VARIABILI
# Coefficienti della retta
var a :=  1;
var b := -1;
var c :=  0;
var w {P} binary;	# w=1 significa misclassification
var delta >=0;

# VINCOLI
# Vincolo di normalizzazione dei coefficienti
subject to Norm: a^2 + b^2 = 1;

# Vincolo sulla separazione dei punti
subject to Separa0 {i in P: f[i]=0}:
  a*x[i] + b*y[i] + c <= -delta + M * w[i];
subject to Separa1 {i in P: f[i]=1}:
  a*x[i] + b*y[i] + c >=  delta - M * w[i];

# OBIETTIVO
# Minimizzare numero di misclassifications
#minimize z1: sum {i in P} w[i];
subject to Obj1: sum {i in P} w[i] <= 5;

maximize z2: delta;

#######################################
data;
param nP := 20;
param:  x    y     f := 
  1    12   29     1
  2    16   26     1
  3    24   25     1
  4     8    7     1
  5    30   50     1
  6    11   41     1
  7     5    2     1
  8     6   11     1
  9    40   12     1
 10    23   27     1
 11    21   43     1
 12    51   18     1
 13     2   36     0
 14     2   33     0
 15    11    6     0
 16    33    7     0
 17    28   45     0
 18    25   42     0
 19    20   50     0
 20    20   18     0;
